package br.gov.mj.side.web.dto;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

import br.gov.mj.side.entidades.enums.EnumTipoAgrupamentoLicitacao;
import br.gov.mj.side.entidades.programa.licitacao.AgrupamentoLicitacao;

public class ItemBemDto implements Serializable{
    private static final long serialVersionUID = 1L;
    
    private Integer contadorTemp;
    private AgrupamentoLicitacao agrupamentoLicitacao;
    private LicitacaoNomeModelDto nomeModelDto;
    private EnumTipoAgrupamentoLicitacao tipoAgrupamentoLicitacao;
    private List<BemUfDto> listaDeBens = new ArrayList<BemUfDto>();
    private String unidadeDeMedida;
    private Long quantidadeRegistrar;
    private BigDecimal valorUnitario;
    private BigDecimal valorTotal;
   
    
    public EnumTipoAgrupamentoLicitacao getTipoAgrupamentoLicitacao() {
        return tipoAgrupamentoLicitacao;
    }
    public void setTipoAgrupamentoLicitacao(EnumTipoAgrupamentoLicitacao tipoAgrupamentoLicitacao) {
        this.tipoAgrupamentoLicitacao = tipoAgrupamentoLicitacao;
    }
    public List<BemUfDto> getListaDeBens() {
        return listaDeBens;
    }
    public void setListaDeBens(List<BemUfDto> listaDeBens) {
        this.listaDeBens = listaDeBens;
    }
    public String getUnidadeDeMedida() {
        return unidadeDeMedida;
    }
    public void setUnidadeDeMedida(String unidadeDeMedida) {
        this.unidadeDeMedida = unidadeDeMedida;
    }
    public Long getQuantidadeRegistrar() {
        return quantidadeRegistrar;
    }
    public void setQuantidadeRegistrar(Long quantidadeRegistrar) {
        this.quantidadeRegistrar = quantidadeRegistrar;
    }
    public BigDecimal getValorTotal() {
        return valorTotal;
    }
    public void setValorTotal(BigDecimal valorTotal) {
        this.valorTotal = valorTotal;
    }
    public AgrupamentoLicitacao getAgrupamentoLicitacao() {
        return agrupamentoLicitacao;
    }
    public void setAgrupamentoLicitacao(AgrupamentoLicitacao agrupamentoLicitacao) {
        this.agrupamentoLicitacao = agrupamentoLicitacao;
    }
    public LicitacaoNomeModelDto getNomeModelDto() {
        return nomeModelDto;
    }
    public void setNomeModelDto(LicitacaoNomeModelDto nomeModelDto) {
        this.nomeModelDto = nomeModelDto;
    }
    public BigDecimal getValorUnitario() {
        return valorUnitario;
    }
    public void setValorUnitario(BigDecimal valorUnitario) {
        this.valorUnitario = valorUnitario;
    }
    
    public static Comparator<ItemBemDto> getComparator(int order, String coluna) {
        return new Comparator<ItemBemDto>() {
            @Override
            public int compare(ItemBemDto o1, ItemBemDto o2) {
                int valor = 0;

                if ("nome".equalsIgnoreCase(coluna)) {
                    valor = o1.getNomeModelDto().getNomeGrupo().toUpperCase().compareTo(o2.getNomeModelDto().getNomeGrupo().toUpperCase()) * order;
                }
                return valor;
            }
        };
    }
    public Integer getContadorTemp() {
        return contadorTemp;
    }
    public void setContadorTemp(Integer contadorTemp) {
        this.contadorTemp = contadorTemp;
    }
}
