package br.gov.mj.side.web.service;

import java.util.List;

import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.inject.Inject;

import br.gov.mj.side.entidades.AnexoBem;
import br.gov.mj.side.web.dao.AnexoBemDAO;

@Stateless
@TransactionAttribute(TransactionAttributeType.REQUIRED)
public class AnexoBemService {

    @Inject
    private AnexoBemDAO anexoBemDAO;

    public AnexoBem buscarPeloId(Long id) {
        return anexoBemDAO.buscarPeloId(id);
    }

    public List<AnexoBem> buscarPeloIdBem(Long id) {
        if (id == null) {
            throw new IllegalArgumentException("Parmetro id no pode ser null");
        }
        return anexoBemDAO.buscarPeloIdBem(id);
    }

    public Long countPeloIdBem(Long idBem) {
        return anexoBemDAO.countPeloIdBem(idBem);
    }

}
