package br.gov.mj.side.web.service;

import java.util.List;

import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.inject.Inject;

import br.gov.mj.side.entidades.entidade.EntidadeAnexo;
import br.gov.mj.side.web.dao.AnexoEntidadeDAO;

@Stateless
@TransactionAttribute(TransactionAttributeType.REQUIRED)
public class AnexoEntidadeService {

    @Inject
    private AnexoEntidadeDAO anexoEntidadeDAO;

    public EntidadeAnexo buscarPeloId(Long id) {
        return anexoEntidadeDAO.buscarPeloId(id);
    }

    public List<EntidadeAnexo> buscarPeloIdEntidade(Long id) {
        if (id == null) {
            throw new IllegalArgumentException("Parmetro id no pode ser null");
        }
        return anexoEntidadeDAO.buscarPeloIdEntidade(id);
    }

    public Long countPeloIdEntidade(Long idEntidade) {
        return anexoEntidadeDAO.countPeloIdEntidade(idEntidade);
    }

}
