package br.gov.mj.side.web.service;

import java.util.List;

import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.inject.Inject;

import br.gov.mj.side.entidades.programa.ProgramaAnexo;
import br.gov.mj.side.web.dao.AnexoProgramaDAO;

@Stateless
@TransactionAttribute(TransactionAttributeType.REQUIRED)
public class AnexoProgramaService {

    @Inject
    private AnexoProgramaDAO anexoProgramaDAO;

    public ProgramaAnexo buscarPeloId(Long id) {
        return anexoProgramaDAO.buscarPeloId(id);
    }

    public List<ProgramaAnexo> buscarPeloIdPrograma(Long id) {

        if (id == null) {
            throw new IllegalArgumentException("Parmetro id no pode ser null");
        }

        return anexoProgramaDAO.buscarPeloIdPrograma(id);
    }

    public Long countPeloIdPrograma(Long idPrograma) {
        return anexoProgramaDAO.countPeloIdPrograma(idPrograma);
    }

}
