package br.gov.mj.side.web.util;

import java.util.Iterator;

import org.apache.wicket.extensions.markup.html.repeater.data.sort.SortOrder;
import org.apache.wicket.extensions.markup.html.repeater.util.SortableDataProvider;
import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.model.IModel;

import br.gov.mj.infra.negocio.persistencia.EnumOrder;
import br.gov.mj.side.entidades.entidade.Entidade;
import br.gov.mj.side.web.dto.EntidadePesquisaDto;
import br.gov.mj.side.web.service.EntidadeService;

public class SortableEntidadeDataProvider extends SortableDataProvider<Entidade, String> {

    private static final long serialVersionUID = 1L;
    private EntidadeService entidadeService;
    private EntidadePesquisaDto entidadePesquisaDto;

    public SortableEntidadeDataProvider(EntidadeService entidadeService, EntidadePesquisaDto entidadePesquisaDto) {
        this.entidadePesquisaDto = entidadePesquisaDto;
        this.entidadeService = entidadeService;
        setSort("nomeEntidade", SortOrder.ASCENDING);
    }

    @Override
    public Iterator<? extends Entidade> iterator(long first, long count) {
        return entidadeService.buscarPaginado(entidadePesquisaDto, (int) first, (int) count, getSort().isAscending() ? EnumOrder.ASC : EnumOrder.DESC, getSort().getProperty()).iterator();

    }

    @Override
    public long size() {
        return entidadeService.buscarSemPaginacao(entidadePesquisaDto).size();
    }

    @Override
    public IModel<Entidade> model(Entidade object) {
        return new CompoundPropertyModel<Entidade>(object);
    }

}
