package br.gov.mj.side.web.view;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;

import org.apache.wicket.Page;
import org.apache.wicket.markup.html.WebMarkupContainer;
import org.apache.wicket.markup.html.panel.Panel;

import br.gov.mj.infra.wicket.component.ComponentFactory;
import br.gov.mj.infra.wicket.component.InfraAjaxFallbackLink;
import br.gov.mj.seg.entidades.Usuario;
import br.gov.mj.side.entidades.entidade.Entidade;
import br.gov.mj.side.web.service.EntidadeService;
import br.gov.mj.side.web.view.consultaPublica.ConsultaPublicaPesquisaPage;
import br.gov.mj.side.web.view.dashboard.DashboardInfoEntidadePage;
import br.gov.mj.side.web.view.dashboard.DashboardInscricoesPage;
import br.gov.mj.side.web.view.dashboard.InformacoesEntidadePage;
import br.gov.mj.side.web.view.dashboard.InformacoesGeraisRepresentantePage;

public class DashboardPanel extends Panel {
    private static final long serialVersionUID = 1L;

    private Page backPage;
    private HomePage homePage;
    private Usuario usuarioLogado;
    private Entidade entidadeLogada;

    private PanelBotoesDashboard panelBotoesDashboard;

    private List<Entidade> listaRetorno = new ArrayList<Entidade>();

    @Inject
    private ComponentFactory componentFactory;

    @Inject
    private EntidadeService entidadeService;

    public DashboardPanel(String id) {
        super(id);
        setOutputMarkupId(true);

        initVariaveis();
        initComponents();
    }

    private void initVariaveis() {
        // Inicializar as variáveis
    }

    private void initComponents() {
        panelBotoesDashboard = new PanelBotoesDashboard("panelBotoesDashboard");
        add(panelBotoesDashboard);
    }

    private class PanelBotoesDashboard extends WebMarkupContainer {
        private static final long serialVersionUID = 1L;

        public PanelBotoesDashboard(String id) {
            super(id);

            add(getButtonInformacoesGeraid()); // btnInformacoesGerais
            add(getButtonInformacoesEntidade()); // btnInformacoesEntidade
            add(getButtonPesquisaAberta()); // btnPesquisaAberta
            add(getButtonInscricoes()); // btnInscricoes
        }
    }

    // COMPONENTES

    public InfraAjaxFallbackLink<Void> getButtonInformacoesGeraid() {
        return componentFactory.newAjaxFallbackLink("btnInformacoesGerais", (target) -> informacoesGerais());
    }

    public InfraAjaxFallbackLink<Void> getButtonInformacoesEntidade() {
        InfraAjaxFallbackLink<Void> buttonInfoEntidade = componentFactory.newAjaxFallbackLink("btnInformacoesEntidade", (target) -> informacoesEntidade());
        return buttonInfoEntidade;
    }

    public InfraAjaxFallbackLink<Void> getButtonInscricoes() {
        InfraAjaxFallbackLink<Void> buttonInfoInscricoes = componentFactory.newAjaxFallbackLink("btnInscricoes", (target) -> inscricoes());
        return buttonInfoInscricoes;
    }

    public InfraAjaxFallbackLink<Void> getButtonPesquisaAberta() {
        InfraAjaxFallbackLink<Void> buttonPesquisa = componentFactory.newAjaxFallbackLink("btnPesquisaAberta", (target) -> pesquisaAberta());
        return buttonPesquisa;
    }

    // AÇÕES

    private void informacoesGerais() {
        // setResponsePage(new
        // InformacoesGeraisRepresentantePage(null,backPage));
        setResponsePage(new InformacoesGeraisRepresentantePage(null));
    }

    private void informacoesEntidade() {
        setResponsePage(new InformacoesEntidadePage(null));
    }

    private void inscricoes() {
        setResponsePage(new DashboardInscricoesPage(null));
    }

    private void pesquisaAberta() {
        setResponsePage(new ConsultaPublicaPesquisaPage(null));
    }
}
