package br.gov.mj.side.web.view.planejarLicitacao.minutaTR;

import java.io.ByteArrayOutputStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;
import net.sf.jasperreports.engine.export.HtmlExporter;
import net.sf.jasperreports.engine.export.JRCsvExporter;
import net.sf.jasperreports.engine.export.JRPdfExporter;
import net.sf.jasperreports.engine.export.JRPdfExporterParameter;
import net.sf.jasperreports.engine.export.JRRtfExporter;
import net.sf.jasperreports.engine.export.JRTextExporter;
import net.sf.jasperreports.engine.export.JRTextExporterParameter;
import net.sf.jasperreports.engine.export.JRXlsExporter;
import net.sf.jasperreports.engine.export.oasis.JROdtExporter;
import net.sf.jasperreports.engine.util.JRLoader;
import net.sf.jasperreports.export.SimpleExporterInput;
import net.sf.jasperreports.export.SimpleHtmlExporterOutput;
import net.sf.jasperreports.export.SimpleOutputStreamExporterOutput;
import net.sf.jasperreports.export.SimpleWriterExporterOutput;
import net.sf.jasperreports.export.SimpleXlsReportConfiguration;

import org.slf4j.Logger;

public class MinutaBuilder {

    private static final String REPORT_PATH = "/reports/minuta_termo_referencia.jasper";

    private static Logger logger;
    public ByteArrayOutputStream export() {
        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
        try {
            URL arquivo = getClass().getResource(REPORT_PATH);
            JasperReport jasperReport = (JasperReport) JRLoader.loadObject(arquivo);

            ArrayList dataList = getDataBeanList();
            JRBeanCollectionDataSource beanColDataSource = new JRBeanCollectionDataSource(dataList);

            Map parameters = new HashMap();
            JasperPrint print = JasperFillManager.fillReport(jasperReport, parameters, beanColDataSource);

            JROdtExporter exporterOdt = new JROdtExporter();
            exporterOdt.setExporterInput(new SimpleExporterInput(print));
            exporterOdt.setExporterOutput(new SimpleOutputStreamExporterOutput("C://teste//sample_report.odt"));
            exporterOdt.exportReport();

        } catch (JRException jre) {
            jre.printStackTrace();
        }
        return outputStream;
    }

    public ArrayList<MinutaDto> getDataBeanList() {
        ArrayList<MinutaDto> dataBeanList = new ArrayList<MinutaDto>();

        dataBeanList.add(produce("Manisha"));
        dataBeanList.add(produce("Dennis Ritchie"));
        dataBeanList.add(produce("V.Anand"));
        dataBeanList.add(produce("Shrinath"));

        return dataBeanList;
    }

    private MinutaDto produce(String name) {
        MinutaDto dataBean = new MinutaDto();
        dataBean.setTeste(name);
        return dataBean;
    }

}
