package br.gov.mj.side.web.view.programa.inscricao;

import org.apache.wicket.AttributeModifier;
import org.apache.wicket.Page;
import org.apache.wicket.markup.html.WebMarkupContainer;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.request.mapper.parameter.PageParameters;

import br.gov.mj.side.entidades.programa.inscricao.InscricaoPrograma;
import br.gov.mj.side.web.view.programa.inscricao.locaisEntrega.EntregaInscricaoProgramaPage;

public class InscricaoNavPanel extends Panel {

    private static final long serialVersionUID = 1L;

    public InscricaoNavPanel(String id, InscricaoPrograma inscricao, Page backPage, Page page) {
        super(id);
        Link<Void> lnkInscricao = new Link<Void>("lnkInscricao") {
            private static final long serialVersionUID = 1L;

            @Override
            public void onClick() {
                setResponsePage(new InscricaoProgramaPage(new PageParameters(), inscricao, backPage, true));
            }
        };
        WebMarkupContainer containerInscricao = new WebMarkupContainer("containerInscricao");
        containerInscricao.add(lnkInscricao);
        add(containerInscricao);

        Link<Void> lnkEntrega = new Link<Void>("lnkEntrega") {
            private static final long serialVersionUID = 1L;

            @Override
            public void onClick() {
                setResponsePage(new EntregaInscricaoProgramaPage(new PageParameters(), inscricao));
            }
        };
        WebMarkupContainer containerEntrega = new WebMarkupContainer("containerEntrega");
        containerEntrega.add(lnkEntrega);
        add(containerEntrega);

        if (page instanceof InscricaoProgramaPage) {
            containerInscricao.add(AttributeModifier.append("class", "active"));
        } else if (page instanceof EntregaInscricaoProgramaPage) {
            containerEntrega.add(AttributeModifier.append("class", "active"));
        }
    }

}
