package br.gov.mj.side.web.view.programa.visualizacao;

import javax.inject.Inject;

import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.request.mapper.parameter.PageParameters;

import br.gov.mj.side.entidades.programa.Programa;
import br.gov.mj.side.web.service.ProgramaService;
import br.gov.mj.side.web.view.template.TemplatePage;




public class ProgramaTestePage extends TemplatePage {
    private static final long serialVersionUID = 1L;
    
    @Inject
    private ProgramaService programaService;

    private Form<Void> form;
    
    public ProgramaTestePage(final PageParameters pageParameters) {
        super(pageParameters);
        initComponents();
    }

    private void initComponents() {
        
        form = new Form<Void>("form");
        
        Programa programa = new Programa();
        programa.setId(38L);
        
        programa = programaService.buscarPeloId(programa.getId());
        programa.setCriteriosAcompanhamento(programaService.buscarProgramaCriterioAcompanhamento(programa));
        programa.setCriteriosElegibilidade(programaService.buscarProgramaCriterioElegibilidade(programa));
        programa.setProgramaBens(programaService.buscarProgramaBem(programa));
        programa.setProgramaKits(programaService.buscarProgramakit(programa));
        programa.setPotenciaisBeneficiariosUf(programaService.buscarProgramaPotencialBeneficiarioUf(programa));
        programa.setRecursosFinanceiros(programaService.buscarProgramaRecursoFinanceiroPeloIdPrograma(programa));
        programa.setAnexos(programaService.buscarAnexosPeloProgramaId(programa.getId()));
        programa.setHistoricoPublicizacao(programaService.buscarHistoricoPublicizacao(programa));
        
        
        
        //Programa programa = genericPersister.findById(Programa.class, 31l);
        
//        Set<ProgramaPotencialBeneficiarioUf> listaUf = new HashSet<ProgramaPotencialBeneficiarioUf>(programa.getPotenciaisBeneficiariosUf());
//        programa.setPotenciaisBeneficiariosUf(new ArrayList<ProgramaPotencialBeneficiarioUf>(listaUf));
        
        ProgramaPanel programaPanel = new ProgramaPanel("programaPanel",programa);
        form.add(programaPanel);
        
        add(form);
        
    }

}